(*                                                                          *)
(* (c) 2004, 2005 Anastasia Gornostaeva. <ermine@ermine.pp.ru>              *)
(*                                                                          *)

open Sqlite

let rc_to_string rc =
   match rc with		     
      | RC_ok -> "RC_ok"
      | RC_error -> "RC_error"
      | RC_internal -> "RC_internal"
      | RC_perm -> "RC_perm"
      | RC_abort -> "RC_abort"
      | RC_busy -> "RC_busy"
      | RC_locked -> "RC_locked"
      | RC_nomem -> "RC_nomem"
      | RC_readonly -> "RC_readonly"
      | RC_interrupt -> "RC_interrupt"
      | RC_ioerr -> "RC_ioerr"
      | RC_corrupt -> "RC_corrupt"
      | RC_notfound -> "RC_notfound"
      | RC_full -> "RC_full"
      | RC_cantopen -> "RC_cantopen"
      | RC_protocol -> "RC_protocol"
      | RC_empty -> "RC_empty"
      | RC_schema -> "RC_schema"
      | RC_toobig -> "RC_toobig"
      | RC_constraint -> "RC_constraint"
      | RC_mismatch -> "RC_mismatch"
      | RC_misuse -> "RC_missure"
      | RC_nofls -> "RC_nofls"
      | RC_auth -> "RC_auth"
      | RC_format -> "RC_format"

(*	    
let r = Pcre.regexp "(['\"]чи)"

let escape str = 
   let t = Pcre.substitute_substrings ~rex:r
      ~subst:(fun a -> "\\" ^ Pcre.get_substring a 1) str in
      "'" ^ t ^ "'"
*)

let string_after s n =
  String.sub s n (String.length s - n)

let escape str =
   let rec aux tail acc =
      try
	 let q = String.index tail '\'' in
	    aux (string_after tail (q+1))
	       (((String.sub tail 0 q) ^ "''") :: acc)
      with Not_found -> tail :: acc
   in
      "'" ^ (String.concat "" (List.rev (aux str []))) ^ "'"

let result_bool db sql =
   let vm = 
      Sqlite.compile_simple db sql in
      try 
	 let _ = step_simple vm in
	    finalize vm;
	    true
      with Sqlite_done ->
	 false

let result_integer db sql =
   let vm = compile_simple db sql in
      try
	 let result = step_simple vm in
	    finalize vm;
	    int_of_string (result.(0))
      with _ -> raise Not_found

let values (data:string list) =
   "VALUES(" ^ String.concat ", " data ^ ")"
